<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2014/04/14
// Version    : 3.30
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// control.php
//
//--------------------------------------------------------------------

$module_version = "3.30";

global $blogn_admin;
if (!$blogn_admin) exit;

$menu = array(1 => "ログ", "設定", "説明", "独自タグ", "インストール", "モジュール情報");

require BLOGN_MODDIR.$module_name.'/function.php';

$ngwdfile = BLOGN_MODDIR.$module_name.'/ngwd.cgi';
$logfile = BLOGN_MODDIR.$module_name.'/rejected.cgi';
$capfile = BLOGN_MODDIR.$module_name.'/caps.cgi';
$tsfile = BLOGN_MODDIR.$module_name.'/key.cgi';
$inifile = BLOGN_MODDIR.$module_name.'/config.cgi';
$inis = file($inifile);

list($mode, $spm_limit, $cmt[0]["allow"], $cmt[0]["log"], $cmt[0]["mail"], $cmt[1]["allow"], $cmt[1]["log"], $cmt[1]["mail"], $cmt[2]["allow"], $cmt[2]["log"], $cmt[2]["mail"]) = explode(",", $inis[0]);
list($language, $urls, $difference, $wt["lang"], $wt["href"], $wt["bburl"], $wt["bblink"], $wt["atmark"], $wt["https"], $wt["time"], $wt["mail"], $wt["urlincmt"], $wt["redirect"], $wt["ngwd"], $wt["blip"], $wt["proxy"], $wt["badref"], $wt["badua"], $wt["token"], $wt["name"], $wt["eml"]) = explode(",", $inis[1]);
list($name_limit, $trip, $autolink, $quote, $mailcmt, $cap) = explode(",", $inis[2]);

$a4c_tsnames = file($tsfile);
$a4c_tsnames[0] = rtrim($a4c_tsnames[0]);
$a4c_tsnames[1] = rtrim($a4c_tsnames[1]);
$a4c_tsnames[2] = rtrim($a4c_tsnames[2]);

switch($_POST["method"]) {
	case "edit":
		$mode 			= $_POST["mode"];
		$language		= $_POST["language"];
		$urls 			= $_POST["urls"];
		$difference	 	= $_POST["difference"];
		$name_limit		= $_POST["name_limit"];
		$trip			= $_POST["trip"];
		$cap			= $_POST["cap"];
		$autolink		= $_POST["autolink"];
		$quote			= $_POST["quote"];
		$mailcmt		= $_POST["mailcmt"];
		$wt["lang"] 		= $_POST["lang"];		// 言語
		$wt["href"] 		= $_POST["href"];		// HREF
		$wt["bburl"]		= $_POST["bbcode"];		// BB Code (url)
		$wt["bblink"]		= $_POST["bblink"];		// BB Code (link)
		$wt["atmark"]		= $_POST["atmark"];		// アットマーク
		$wt["https"] 		= $_POST["https"];		// URL の羅列
		$wt["time"] 		= $_POST["time"];		// タイムスタンプ
		$wt["mail"]		= $_POST["mail"];		// メール・URL欄
		$wt["urlincmt"]		= $_POST["urlincmt"];	// URL欄
		$wt["redirect"]		= $_POST["redirect"];	// リダイレクト
		$wt["ngwd"]		= $_POST["ngs"];		// 禁止ワード
		$wt["blip"]		= $_POST["blip"];		// IP アドレス
		$wt["proxy"]		= $_POST["proxy"];		// 公開プロキシ
		$wt["badua"]		= $_POST["badua"];		// ユーザーエージェント
		$wt["badref"]		= $_POST["badref"];		// リファラ
		$wt["token"]		= $_POST["token"];		// トークン
		$wt["name"]		= $_POST["name"];		// 投稿者名
		$wt["eml"]		= $_POST["eml"];		// メール
		if ($_POST["ngword"]) $ng = preg_replace("/,+/", ",", $_POST["ngword"]);
		$caparea		= htmlspecialchars($_POST["caparea"], ENT_QUOTES);
		$tsname = asm4cmt_create_tsname();
		$asm4cmt_time = time();
		$spm_limit		= $_POST["spm_limit"];
		switch ($mode) {
			case "1": // A
				$cmt = array(
					"0" => array("allow" => 0, "log" => 0, "mail" => 0),
					"1" => array("allow" => 1, "log" => 0, "mail" => 1),
					"2" => array("allow" => 1, "log" => 0, "mail" => 1)
				);
				break;
			case "2": // B
				$cmt = array(
					"0" => array("allow" => 0, "log" => 1, "mail" => 0),
					"1" => array("allow" => 1, "log" => 0, "mail" => 1),
					"2" => array("allow" => 1, "log" => 0, "mail" => 1)
				);
				break;
			case "3": // C
				$cmt = array(
					"0" => array("allow" => 1, "log" => 0, "mail" => 1),
					"1" => array("allow" => 1, "log" => 0, "mail" => 1),
					"2" => array("allow" => 1, "log" => 0, "mail" => 1)
				);
				break;
			case "4": // D
				$cmt = array(
					"0" => array("allow" => 0, "log" => 1, "mail" => 0),
					"1" => array("allow" => 2, "log" => 1, "mail" => 1),
					"2" => array("allow" => 2, "log" => 1, "mail" => 1)
				);
				break;
			case "5":  // E
				$cmt[0]["allow"]	= $_POST["ham1"]["allow"];
				if ($cmt[0]["allow"] == 1) {
					$cmt[0]["log"] 	= 0;
				} else {
					$cmt[0]["log"]	= $_POST["ham1"]["log"];
				}
				$cmt[0]["mail"]		= $_POST["ham1"]["mail"];
				$cmt[1]["allow"]	= $_POST["spm0"]["allow"];
				if ($cmt[1]["allow"] == 2) {
					$cmt[1]["log"] 	= 1;
					$cmt[1]["mail"] = 1;
				} elseif($cmt[1]["allow"] == 1) {
					$cmt[1]["log"] 	= 0;
					$cmt[1]["mail"]	= $_POST["spm0"]["mail"];
				} else {
					$cmt[1]["log"]	= $_POST["spm0"]["log"];
					$cmt[1]["mail"]	= $_POST["spm0"]["mail"];
				}
				$cmt[2]["allow"]	= $_POST["spm1"]["allow"];
				if ($cmt[2]["allow"] == 2) {
					$cmt[2]["log"] 	= 1;
					$cmt[2]["mail"] = 1;
				} elseif($cmt[2]["allow"] == 1) {
					$cmt[2]["log"] 	= 0;
					$cmt[2]["mail"]	= $_POST["spm1"]["mail"];
				} else {
					$cmt[2]["log"]	= $_POST["spm1"]["log"];
					$cmt[2]["mail"]	= $_POST["spm1"]["mail"];
				}
				break;
			case "0": // TEST
			default:
				$cmt = array(
					"0" => array("allow" => 0, "log" => 0, "mail" => 0),
					"1" => array("allow" => 0, "log" => 0, "mail" => 0),
					"2" => array("allow" => 0, "log" => 0, "mail" => 0)
				);
				break;

		}
		$fp = fopen($inifile, "w");
		fwrite($fp, "$mode,$spm_limit,{$cmt[0][allow]},{$cmt[0][log]},{$cmt[0][mail]},{$cmt[1][allow]},{$cmt[1][log]},{$cmt[1][mail]},{$cmt[2][allow]},{$cmt[2][log]},{$cmt[2][mail]},\r\n$language,$urls,$difference,$wt[lang],$wt[href],$wt[bburl],$wt[bblink],$wt[atmark],$wt[https],$wt[time],$wt[mail],$wt[urlincmt],$wt[redirect],$wt[ngwd],$wt[blip],$wt[proxy],$wt[badref],$wt[badua],$wt[token],$wt[name],$wt[eml],\r\n$name_limit,$trip,$autolink,$quote,$mailcmt,$cap,", 300);
		fclose($fp);

		if ($_POST["reload"]) {
			$fp = fopen($tsfile, 'w');
			fwrite($fp, "$tsname\r\n$a4c_tsnames[0]\r\n$asm4cmt_time\r\n");
			fclose($fp);
		}

		$fp = fopen($ngwdfile, 'w');
		fwrite($fp, $ng);
		fclose($fp);

		$fp = fopen($capfile, 'w');
		fwrite($fp, $caparea);
		fclose($fp);

		$message = "設定を変更しました";
		$loadtabs = "2";
		break;
	
	case "log_delete":
		if ($_POST["deleteok"]) {
			$fp = fopen($logfile, "w");
			fwrite($fp, "");
			fclose($fp);
		}
		$loadtabs = "1";
		break;

	case "log_return":
		if (isset($_POST["logno"])) {
			$lognumber = $_POST["logno"];
			$asm4cmt_log = file($logfile);
			$asm4cmt_log = array_reverse($asm4cmt_log);
			$log_return = explode(",", $asm4cmt_log[$lognumber]);
			$logdata = blogn_mod_db_log_load_for_editor($log_return[0]);
			
			blogn_mod_db_comment_add($log_return[0], $logdata[1]["secret"], $log_return[2], $log_return[3], $log_return[4], $log_return[5], $log_return[6], $log_return[7], $log_return[8]);
		
			array_splice($asm4cmt_log, $lognumber, 1);
			$asm4cmt_log = array_reverse($asm4cmt_log);
			$fp = fopen($logfile, 'w');
			foreach($asm4cmt_log as $line) {
				fwrite($fp, "$line");
			}
			fclose($fp);
		}
		$loadtabs = "1";
		break;


	default:
		$message = "";
		$loadtabs = "1";
		break;
}
include BLOGN_MODDIR.$module_name.'/menu.php';

echo $js.'
<div class="blogn_main">
<h1'.formatStyle($style["mod_title"]).'>コメントスパム対策モジュール (ver'.$module_version.')</h1>

<!-- LEFT -->
<div'.formatStyle($style["coll"]).'>
<h2'.formatStyle($style["coll_h2"]).'>メニュー</h2>
<ul'.formatStyle($style["coll_ul"]).'>';

module_control_list($menu);

echo '
</ul>
<noscript><p'.formatStyle($style["nojs"]).'>※ Javascript 無効<br />メニュー内のテキストリンクは機能しないので、● をクリックしてナビゲートしてください。</p></noscript>
<p'.formatStyle($style["credit"]).'>Powered by<br /><a href="http://i-njoy.net/blog/" target="_blank"'.formatStyle($style["credit_a"]).'>nJOY BLOG</a></p>
</div>

<!-- RIGHT -->
<div'.formatStyle($style["colr"]).'>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("ログ", $menu).'">

<div class="blogn_bar">ログ</div>
<div'.formatStyle($style["asm_log"]).'>
';
if (!filesize($logfile)) {
	echo '<p'.formatStyle($style["nolog"]).'>ログはありません</p>';
} else {
	echo '<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'">
<input type="hidden" name="method" value="log_return">';
	$asm4cmt_log = file($logfile);
	$asm4cmt_log = array_reverse($asm4cmt_log);
	
	$logcount = count($asm4cmt_log);
	for ($l = 0; $l < $logcount; $l++) {
		$log = explode(",", str_replace("\\", "", $asm4cmt_log[$l]));
		$date = substr($log[2], 0,4).'/'.substr($log[2],4,2).'/'.substr($log[2],6,2).' '.substr($log[2],8,2).':'.substr($log[2],10,2).':'.substr($log[2],12,2);
		$mes = str_replace('\"', '"', $log[6]);
		if (!$log[10]) $log[10] = "??";
		echo '

<h2'.formatStyle($style["asm_log_h2"]).'>[記事ID:'.$log[0].'] '.$date.'<span'.formatStyle($style["reason"]).'>'.asm4cmt_reason($log[1]).'</span>';
if ($log[11] >= 10) {
	echo '<span'.formatStyle($style["pen_l"]).'>';
}elseif ($log[11] == 0) {
	echo '<span'.formatStyle($style["pen_s"]).'>';
} else {
	echo '<span'.formatStyle($style["pen_m"]).'>';
}
echo 'ペナルティ: '.number_format($log[11] * 0.1, 1).'</span></h2>
<div'.formatStyle($style["log_left"]).'>';
if ($log[11] >= 10 || strpos($log[1], "保留")) echo '<input type="radio" name="logno" value="'.$l.'">';
echo '</div>
<div'.formatStyle($style["log_right"]).'>
<h3'.formatStyle($style["asm_log_h3"]).'>';
echo ''.htmlspecialchars($log[3]).' （投稿に要した時間='.$log[10].'秒） ';

		if ($log[5]) {
			echo ' <a href="'.htmlspecialchars($log[5]).'" target="_blank"><img src="./images/url.gif" title="'.htmlspecialchars($log[5]).'" alt=""'.formatStyle($style["asm_log_img"]).'></a>';
		}
		if ($log[4]) {
			echo ' <a href="mailto:'.htmlspecialchars($log[4]).'"><img src="./images/mail.gif" title="'.htmlspecialchars($log[4]).'" alt=""'.formatStyle($style["asm_log_img"]).'></a>';
		}
		$mes = asm4cmt_format_mes($mes);
echo '</h3>
<p'.formatStyle($style["comment"]).'>'.$mes.'</p><hr'.formatStyle($style["seperator"]).' />
<p'.formatStyle($style["commenter"]).'><b>UA</b>: '.htmlspecialchars($log[8]).'<br /><b>IP</b>: '.htmlspecialchars($log[7]).' <b>Ref</b>: '.htmlspecialchars($log[9]).'</p></div>';
	}
}

echo '</div>';
if (filesize($logfile)) {
echo '
<input type="submit" value="保留解除"'.formatStyle($style["button"]).'> 保留されているコメント横のラジオボタンにチェックしてください。
</form>

<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'">
<input type="hidden" name="method" value="log_delete">
<input type="submit" value="ログ一括削除"'.formatStyle($style["button"]).'>
<input type="checkbox" name="deleteok" value="1"> ログを削除する場合は、チェックをつけて [ログ一括削除] ボタンを押してください。
</form>';
}

$asmc_mode["select"] = array("", "", "", "", "", "");
$asmc_mode["select"][$mode] = ' selected="selected"';
$asmc_mode["display"] = array("none", "none", "none", "none", "none", "");

echo '
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("設定", $menu).'">

<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'">

<div class="blogn_bar">現在の設定</div>
<table border="1" cellspacing="0" cellpadding="3" width="600">

<tr bgcolor="#dcdcdc"><th colspan="3">動作設定</th></tr>
<tr>
<td bgcolor="#e9e9e9"><strong>モード選択</strong></td>
<td>モードの詳細は下記説明を参照。</td>
<td><select name="mode"'.formatStyle($style["sel_penalty"]).'">
<option value="0"'.$asmc_mode["select"][0].'>テスト</option>
<option value="1"'.$asmc_mode["select"][1].'>Aモード</option>
<option value="2"'.$asmc_mode["select"][2].'>Bモード</option>
<option value="3"'.$asmc_mode["select"][3].'>Cモード</option>
<option value="4"'.$asmc_mode["select"][4].'>Dモード</option>
<option value="5"'.$asmc_mode["select"][5].'>Eモード</option>
</select>
</td>
</tr>
<tr style="display:'.$asmc_mode["display"][$mode].';">
<td bgcolor="#e9e9e9"><strong>Eモード設定</strong></td>
<td colspan="2">
<table border="1" cellspacing="0" cellpadding="3" width="100%">

<tr bgcolor="#dcdcdc"><th>ペナルティ</th><th>コメントの扱い</th><th>ログへの記録</th><th>メール</th></tr>

<tr>
<td bgcolor="#e9e9e9"><strong>0.0 - 0.9</strong></td>
'.asm4cmt_mode($cmt[0], "ham1").'
</tr>

<tr>			
<td bgcolor="#e9e9e9"><strong>1.0 - <select name="spm_limit">';
for ($i = 19; $i < 100; $i++) {
	asm4cmt_control_option($i, $spm_limit);
}
echo '</select></strong></td>
'.asm4cmt_mode($cmt[1], "spm0").'
</tr>

<tr>			
<td bgcolor="#e9e9e9"><strong>それ以上</strong></td>
'.asm4cmt_mode($cmt[2], "spm1").'
</tr>

</table>

</td></tr>
';
/*
if (file_exists(BLOGN_MODDIR."captcha/viewer.php")) {
	echo '<tr>
<td bgcolor="#e9e9e9"><strong>Captcha</strong></td>
<td colspan="2">キャプチャモジュールが検出されました。画像認証機能が使用可能です。</td>
</tr>';
}
*/
echo '
<tr bgcolor="#dcdcdc"><th colspan="2">スパム認定方法</th><th>ペナルティ</th></tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[非日本語]</strong></td>
<td>';

if ($language == "engng") {
	echo '
<input checked="checked" type="radio" name="language" value="engng" />ひらがな・カタカナ・漢字が五文字連続しない場合<br />
<input type="radio" name="language" value="chnng" />ひらがな・カタカナが三文字連続しない場合<br />';
} else {
	echo '
<input type="radio" name="language" value="engng" />ひらがな・カタカナ・漢字が五文字連続しない場合<br />
<input checked="checked" type="radio" name="language" value="chnng" />ひらがな・カタカナが三文字連続しない場合<br />';
}

echo '
</td>
<td><select name="lang"'.formatStyle($style["sel_penalty"]).'>';

for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["lang"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9" rowspan="1"><strong>[投稿者名]</strong></td>
<td>コメント内に投稿者名が記述されている場合</td>
<td><select name="name"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["name"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9" rowspan="3"><strong>[リンクタグ]</strong></td>
<td>コメント内に &#60;a href="****"&#62;</td>
<td><select name="href"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["href"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td>コメント内に [url=****] </td>
<td><select name="bbcode"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["bburl"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td>コメント内に [link=****] </td>
<td><select name="bblink"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["bblink"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[@]</strong></td>
<td>コメント内にメールアドレスが記述されている場合</td>
<td><select name="atmark"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["atmark"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[URL羅列]</strong></td>
<td>コメント内に URL が <select name="urls">';

for ($i = 1; $i < 11; $i++) {
	if ( $urls == $i ) {
		echo '<option selected value="'.$i.'">'.$i.'</option>';
	}else{
		echo '<option value="'.$i.'">'.$i.'</option>';
	}
}
echo '
</select> 回以上記述されている場合</td>
<td><select name="https"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["https"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[投稿時間]</strong></td>
<td>コメント投稿に要した時間が <select name="difference">';

for ($i = 16; $i < 301; $i++) {
	if ( $difference == $i ) {
		echo '<option selected value="'.$i.'">'.$i.'</option>';
	}else{
		echo '<option value="'.$i.'">'.$i.'</option>';
	}
}
echo '
</select> 秒以下の場合</td>
<td><select name="time"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["time"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[MAIL+URL]</strong></td>
<td>メール欄とURL欄の両方に記入がある場合</td>
<td><select name="mail"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["mail"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[MAIL]</strong></td>
<td>メール欄に記入がある場合</td>
<td><select name="eml"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["eml"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[重複URL]</strong></td>
<td>URL欄に記入されたURLがコメント内に記述されている場合</td>
<td><select name="urlincmt"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["urlincmt"]);
}
echo '
</select>
</td>
</tr>


<tr>
<td bgcolor="#e9e9e9"><strong>[リダイレクト]</strong></td>
<td>リンク先にリダイレクトが仕組まれている場合</td>
<td><select name="redirect"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["redirect"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[IPアドレス]</strong></td>
<td>「スパムちゃんぷるー」に登録されていた場合（スパムに有効）</td>
<td><select name="blip"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["blip"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[プロキシ]</strong></td>
<td>公開プロキシ経由で書き込まれた場合（荒らしに有効）</td>
<td><select name="proxy"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["proxy"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[リファラ]</strong></td>
<td>リファラなし、または不正なリファラが検出された場合</td>
<td><select name="badref"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["badref"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[UA]</strong></td>
<td>不正なユーザーエージェントが検出された場合</td>
<td><select name="badua"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["badua"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>[トークン]</strong></td>
<td>トークンが送信されなかった場合</td>
<td><select name="token"'.formatStyle($style["sel_penalty"]).'>';
for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["token"]);
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9" rowspan="2"><strong>[禁止ワード]</strong></td>
<td>コメントまたは URL 欄に指定した禁止ワード（↓）が含まれていた場合</td>
<td><select name="ngs"'.formatStyle($style["sel_penalty"]).'>';

for ($i = 0; $i < 12; $i++) {
	asm4cmt_control_option($i, $wt["ngwd"]);
}
$ng = fopen($ngwdfile, 'r');
$line = fgets($ng);

echo '
</select>
</td>
</tr>

<tr><td colspan="2"><input type="text" name="ngword" value="'.$line.'" size="80" /></td>
</tr>';
fclose($ng);



if (BLOGN_MBS) {
	$nc_message = " 文字 （日本語も半角英文字も1文字としてカウントします）";
}else{
	$nc_message = " bytes （日本語は１文字あたり 3 bytes、半角英文字は 1 byte としてカウント）";
}


echo '
<tr><td colspan="3" bgcolor="#dcdcdc"><strong>荒らし対策</strong></td></tr>
<tr>
<td bgcolor="#e9e9e9"><strong>投稿者名文字数制限</strong></td>
<td colspan="2"><select name="name_limit">';

for ($i = 10; $i < 100; $i++) {
	if ( $name_limit == $i ) {
		echo '<option selected value="'.$i.'">'.$i.'</option>';
	}else{
		echo '<option value="'.$i.'">'.$i.'</option>';
	}
}
echo '
</select>'.$nc_message.'</td>
</tr>
<tr><td bgcolor="#e9e9e9"><strong>トリップ機能</strong></td>
<td colspan="2">';
if ($trip == "tripon") {
	echo '
<input type="radio" name="trip" value="tripoff" /> OFF
<input checked="checked" type="radio" name="trip" value="tripon" /> ON';
} else {
	echo '
<input checked="checked" type="radio" name="trip" value="tripoff" /> OFF
<input type="radio" name="trip" value="tripon" /> ON';
}
echo '</td></tr>
<tr><td bgcolor="#e9e9e9"><strong>キャップ機能</strong></td>
<td colspan="2">';
if ($cap == "capon") {
	echo '
<input type="radio" name="cap" value="capoff" /> OFF
<input type="radio" name="cap" value="capon" checked="checked" /> ON';
} else {
	echo '
<input type="radio" name="cap" value="capoff" checked="checked" /> OFF
<input type="radio" name="cap" value="capon" /> ON';
}
echo '</td></tr>';

if ($cap != "capon") {
	$cap_message = array('キャップ機能は無効になっています。', ' style="display:none;width:400px;"');
} else {
	$cap_message = array('記述形式：キャップパスワード=キャップ名<br />', ' style="width:400px;margin:5px;"');
}
	echo '
<tr>
<td bgcolor="#e9e9e9"><strong>キャップ発行</strong></td>
<td colspan="2">'.$cap_message[0].'<textarea name="caparea" cols="60" rows="6"'.$cap_message[1].'>'.file_get_contents($capfile).'</textarea></td>
</tr>';

echo '<tr><td colspan="3" bgcolor="#dcdcdc"><strong>拡張機能</strong></td></tr>
<tr>
<td bgcolor="#e9e9e9"><strong>URL オートリンク</strong></td>
<td colspan="2">';
if ($autolink == "self") {
echo '
<input type="radio" name="autolink" value="nolink">オートリンク無効<br />
<input checked="checked" type="radio" name="autolink" value="self">オートリンク有効（同一ウィンドウでリンクを開く）<br />
<input type="radio" name="autolink" value="blank">オートリンク有効（新規ウィンドウでリンクを開く）<br />
';
} elseif ($autolink == "blank") {
echo '
<input type="radio" name="autolink" value="nolink">オートリンク無効<br />
<input type="radio" name="autolink" value="self">オートリンク有効（同一ウィンドウでリンクを開く）<br />
<input checked="checked" type="radio" name="autolink" value="blank">オートリンク有効（新規ウィンドウでリンクを開く）<br />
';
} else {
echo '
<input checked="checked" type="radio" name="autolink" value="nolink">オートリンク無効<br />
<input type="radio" name="autolink" value="self">オートリンク有効（同一ウィンドウでリンクを開く）<br />
<input type="radio" name="autolink" value="blank">オートリンク有効（新規ウィンドウでリンクを開く）<br />
';
}

echo '</td></tr>
<tr><td bgcolor="#e9e9e9"><strong>引用強調機能</strong></td>
<td colspan="2">';
if ($quote == "quoteon") {
	echo '
<input type="radio" name="quote" value="quoteoff" /> OFF
<input checked="checked" type="radio" name="quote" value="quoteon" /> ON';
} else {
	echo '
<input checked="checked" type="radio" name="quote" value="quoteoff" /> OFF
<input type="radio" name="quote" value="quoteon" /> ON';
}
echo '</td></tr>

<tr>
<td bgcolor="#e9e9e9"><strong>通知メール本文に</strong></td>
<td colspan="2">';
if ($mailcmt == "nocomment") {
echo '
<input checked="checked" type="radio" name="mailcmt" value="nocomment" />コメントを含めない 
<input type="radio" name="mailcmt" value="comment" />コメントを含める
';
}else{
echo '
<input type="radio" name="mailcmt" value="nocomment" />コメントを含めない 
<input checked="checked" type="radio" name="mailcmt" value="comment" />コメントを含める
';
}

echo '</td></tr>
</table>

<input type="hidden" name="method" value="edit">
<input type="submit" value="変更"'.formatStyle($style["button"]).'><input type="checkbox" name="reload" value="1"> 設定変更と一緒にパスキーも再生成する<br />
 <span'.formatStyle($style["message"]).'>'.$message.'</span>
</form>

<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("説明", $menu).'">
<div class="blogn_bar">説明</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>スパム認定方法</h2>
<p'.formatStyle($style["mod_p"]).'>詳しい説明は <a href="http://i-njoy.net/tips/pp_asm4cmt.php">http://i-njoy.net/tips/pp_asm4cmt.php</a> を参照してください。<br />'.urldecode("%E5%85%A5%E5%AE%A4%E7%94%A8%E3%83%91%E3%82%B9%E3%83%AF%E3%83%BC%E3%83%89%EF%BC%9D%E3%80%8C&#104;&#105;&#114;&#97;&#107;&#101;&#103;&#111;&#109;&#97;%E3%80%8D").'</p>

<h2'.formatStyle($style["mod_h2"]).'>仕組み</h2>
<p'.formatStyle($style["mod_p"]).'>コメントに対して14種の条件でスパムかどうか判断します。条件に適合していればその条件に設定されたペナルティが加算され、合計ペナルティが「1.0」以上でスパムと判定されます。<br />各条件に与えられるペナルティは0.1ポイント刻みで「0.0～1.0」の間に設定できます。<br />ペナルティ値に「即削除」を指定すると、その条件に合致した時点で即スパムと判定され、すべての判定を無視し削除します。</p>

<h2'.formatStyle($style["mod_h2"]).'>モード選択について</h2>
<dl'.formatStyle($style["mod_p"]).'>
<dt>テストモード</dt><dd>スパム排除機能OFF。全てのコメントをログに記録します。</dd>
<dt>Aモード</dt><dd>オール（All）モード：スパム排除機能ON。スパムでないコメントも全てログに記録します。</dd>
<dt>Bモード</dt><dd>ブロック（Block）モード：スパム排除機能ON。スパムと判定されたコメントのみログに記録します。</dd>
<dt>Cモード</dt><dd>チェック（Check）モード：すべてのコメントを保留します。スパム判定は行いません。</dd>
<dt>Dモード</dt><dd>デリート（Delete）モード：スパム排除機能ON。ログへの記録はしません。</dd>
<dt>Eモード</dt><dd>エキスパート（Expert）モード：柔軟な設定が行えます（上級者向け）。</dd>
</dl>

<h2'.formatStyle($style["mod_h2"]).'>禁止ワードについて</h2>
<ul'.formatStyle($style["mod_list"]).'>
<li>禁止ワードは「コメント」と「URL」欄に適用されます。</li>
<li>単語は半角コンマで区切って入力してください。</li>
<li>半角英文字の大文字・小文字の区別はしません。</li>
<li>PHP の正規表現を使う事が出来ます。<br />
（例： cas[i1]n[o0] と入力すれば、casino でも cas1no でも CAS1N0 でもヒットします）</li>
</ul>

<h2'.formatStyle($style["mod_h2"]).'>トリップ機能について</h2>
<p'.formatStyle($style["mod_p"]).'>名前の後に「#任意の文字列」を入力する事で「◆ランダムな文字列」に変換されます。<br />なりすまし対策として有効です。</p>

<h2'.formatStyle($style["mod_h2"]).'>キャップ機能について</h2>
<p'.formatStyle($style["mod_p"]).'>メール欄に「#キャップパスワード」を入力する事で、投稿者名があらかじめ設定されている「キャップ名★」に変換されます。<br />トリップ機能同様、なりすまし対策に有効です。<br />名前欄にトリップパスワード、メール欄にキャップパスワードが入力された場合、キャップが優先され、投稿者名にトリップは付加されません。</p>

<h2'.formatStyle($style["mod_h2"]).'>投稿者名文字数制限について</h2>
<p'.formatStyle($style["mod_p"]).'>トリップを生成するために使われるトリップキーは文字数制限の対象になりません。対象になるのは「#」の前の文字列のみです。</p>

<h2'.formatStyle($style["mod_h2"]).'>引用強調機能について</h2>
<p'.formatStyle($style["mod_p"]).'>行頭に「＞」（全角）または「>」（半角）が書かれていた場合、引用とみなされます。その行は &#60;span class="cmtquote"&#62;～&#60;/span&#62; で囲まれます。</p>
</div>
<hr'.formatStyle($style["hr"]).' />

</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("独自タグ", $menu).'">
<div class="blogn_bar">独自タグ</div>
<div'.formatStyle($style["mod"]).'>
<h2'.formatStyle($style["mod_h2"]).'>このモジュールで使える独自タグ</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="100">独自タグ</th><th>説明</th><th width="50">補足</th></tr>
<tr><td>{ASMCT}</td><td>投稿フォーム内で使用</td><td>必須</td></tr>
<tr><td>{ASMCN}</td><td>投稿フォーム内で使用</td><td>必須</td></tr>
<tr><td>{ASMCT_COUNT}</td><td>ログに記録されているコメントの件数を表示</td><td>-</td></tr>
</table>

<h2'.formatStyle($style["mod_h2"]).'>このモジュールで出力するスタイルシート用クラス</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="100">クラス名</th><th>説明</th><th width="50">HTML</th><th width="50">補足</th></tr>
<tr><td>cmtquote</td><td>引用部分（引用強調機能使用時）</td><td>span</td><td>-</td></tr>
</table>

</div>

<hr'.formatStyle($style["hr"]).' />
</div>


<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("インストール", $menu).'">
<div class="blogn_bar">インストール</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>インストール方法</h2>
<ol'.formatStyle($style["mod_list"]).'>
<li>「caps.cgi」「config.cgi」「key.cgi」「ngwd.cgi」「rejected.cgi」のパーミッションを「666」等に変更する。</li>
<li>スキンの HTML ファイルに追記。</li>
<li>携帯用スキンに追記。</li>
<li>モジュールの設定を変更する。</li>
'.$mod_control["co_start"].'<li>モジュール管理画面から動作スイッチを ON にする必要があります。<br />OFF の場合はスパムにたいして無防備の BlognPlus のコメント投稿処理が使用されます。</li>'.$mod_control["co_end"].'
</ol>

<h3'.formatStyle($style["mod_h3"]).'>■ スキンのHTMLファイルに追記</h3>
<p'.formatStyle($style["mod_p"]).'>コメント投稿フォーム内に<b'.formatStyle($style["red"]).'>赤文字部分</b>を追加する。</p>
<pre'.formatStyle($style["pre"]).'>
&#60;form action="index.php?mode=comment" method="post"&#62;
    &#60;input type="hidden" value="{CEID}" name="blogn_cid"&#62;
    <b'.formatStyle($style["red"]).'>&#60;input type="hidden" value="{ASMCT}" name="{ASMCN}"&#62;</b>
    <b'.formatStyle($style["blue"]).'>&#60;input type="hidden" value="{TOKEN}" name="blogn_token"&#62;</b>
    &#60;label for="c_name"&#62;name:&#60;/label&#62;&#60;br&#62;
    &#60;input id="c_name" name="blogn_cname" value="{CNAME}"&#62;&#60;br&#62;
    &#60;label for="c_email"&#62;email:&#60;/label&#62;&#60;br&#62;
    &#60;input id="c_email" name="blogn_cemail" value="{CEMAIL}"&#62;&#60;br&#62;
    &#60;label for="c_url"&#62;URL:&#60;/label&#62;&#60;br&#62;
    &#60;input id="c_url" name="blogn_curl" value="{CURL}"&#62;&#60;br&#62;
    &#60;label for="c_mes"&#62;comments:&#60;/label&#62;&#60;br&#62;
    &#60;textarea id="c_mes" name="blogn_cmes" rows="10" cols="40"&#62;
    &#60;/textarea&#62;&#60;br&#62;&#60;br&#62;
    &#60;input type="submit" value="コメント送信"&#62;
    &#60;input id="set_cookie" type="checkbox" value="on" name="set_cookie"&#62;
    &#60;label for="set_cookie"&#62;Cookieに登録&#60;/label&#62;
&#60;/form&#62;
</pre>

<h3'.formatStyle($style["mod_h3"]).'>■ 携帯用スキンに追記</h3>
<p'.formatStyle($style["mod_p"]).'>コメント投稿フォーム内に<b'.formatStyle($style["red"]).'>赤文字部分</b>を追加する。</p>
<pre'.formatStyle($style["pre"]).'>
&#60;form action="index.php" method="post"&#62;
    &#60;input type="hidden" value="comment" name="mode"&#62;
    <b'.formatStyle($style["red"]).'>&#60;input type="hidden" value="{ASMCT}" name="{ASMCN}"&#62;</b>
    <b'.formatStyle($style["blue"]).'>&#60;input type="hidden" value="{TOKEN}" name="blogn_token"&#62;</b>
    &#60;input type="hidden" value="{CEID}" name="blogn_cid"&#62;
    &#60;label for="c_name"&#62;name:&#60;/label&#62;&#60;br&#62;
    &#60;input type="text" id="c_name" size="8" name="blogn_cname" value="{CNAME}"&#62;&#60;br&#62;
    &#60;label for="c_email"&#62;email:&#60;/label&#62;&#60;br&#62;
    &#60;input type="text" id="c_email" size="8" name="blogn_cemail" value="{CEMAIL}"&#62;&#60;br&#62;
    &#60;label for="c_url"&#62;URL:&#60;/label&#62;&#60;br&#62;
    &#60;input type="text" id="c_url" size="8" name="blogn_curl" value="{CURL}"&#62;&#60;br&#62;
    &#60;label for="c_mes"&#62;comments:&#60;/label&#62;&#60;br&#62;
    &#60;textarea id="c_mes" name="blogn_cmes" rows="2" cols="20"&#62;&#60;/textarea&#62;
    &#60;br&#62;&#60;br&#62;
    &#60;input type="submit" value="コメント送信"&#62;
&#60;/form&#62;
</pre>
<p'.formatStyle($style["mod_p"]).'><b'.formatStyle($style["blue"]).'>青文字部分</b>のトークン処理も必須です。</p>

</div>
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("モジュール情報", $menu).'">
<div class="blogn_bar">モジュール情報</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>公式サイト</h2>
<p'.formatStyle($style["mod_p"]).'>もっと詳しい情報や最新版モジュールのダウンロードは「<a href="http://i-njoy.net/tips/plus_asc.shtml" target="_blank">コメントスパム対策モジュール</a>」の解説ページからどうぞ。</p>
<p'.formatStyle($style["mod_p"]).'>最新情報は「<a href="http://i-njoy.net/blog/" target="_blank">nJOY BLOG</a>」から入手できます。</p>

<h2'.formatStyle($style["mod_h2"]).'>モジュール構成ファイル</h2>
<ul'.formatStyle($style["package"]).'>
<li'.formatStyle($style["pack_0"]).'>+ blognplus /</li>
<li'.formatStyle($style["pack_1"]).'>+ module /</li>
<li'.formatStyle($style["pack_2"]).'>+ asm4cmt /</li>
<li'.formatStyle($style["pack_3"]).'>- asm4cmt.php</li>
<li'.formatStyle($style["pack_3"]).'>- blank.php</li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>caps.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>config.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- control.php</li>
<li'.formatStyle($style["pack_3"]).'>- display.php</li>
<li'.formatStyle($style["pack_3"]).'>- function.php</li>
<li'.formatStyle($style["pack_3"]).'>- i_function.php</li>
<li'.formatStyle($style["pack_3"]).'>- index.html</li>
<li'.formatStyle($style["pack_3"]).'>- info.php</li>
<li'.formatStyle($style["pack_3"]).'>- install.php</li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>key.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- menu.php</li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>ngwd.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>rejected.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- spamchk.php</li>
<li'.formatStyle($style["pack_3"]).'>- style.php</li>
<li'.formatStyle($style["pack_3"]).'>- uninstall.php</li>
<li'.formatStyle($style["pack_3"]).'>- update.php</li>
</ul>

<p'.formatStyle($style["mod_p"]).'><span'.formatStyle($style["red"]).'>赤文字のファイル</span>のパーミッションは「666」や「606」に変更してください。</p>

'.$mod_control["co_start"].'
<h2'.formatStyle($style["mod_h2"]).'>動作 ON/OFF</h2>
<p'.formatStyle($style["mod_p"]).'>モジュールをインストール後に、動作のオン・オフを切り替える必要があります。</p>
<dl'.formatStyle($style["mod_dl"]).'>
<dt>PC</dt><dd>「PC」欄を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。[OFF] の場合、BlognPlus のコメント投稿処理が使われます</dd>
<dt>携帯</dt><dd>「携帯」欄 を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。[OFF] の場合、BlognPlus のコメント投稿処理が使われます</dd>
</dl>

<h2'.formatStyle($style["mod_h2"]).'>優先順位</h2>
<ul'.formatStyle($style["mod_list"]).'>
<li>「Comment Captcha」の方を <img src="images/up.gif" width="20" height="20" alt="上" /> にしてください。</li>
</ul>
'.$mod_control["co_end"].'

</div>
<hr'.formatStyle($style["hr"]).' />
</div>

</div>
</div>
</div>';

function asm4cmt_control_option($i, $val) {
	$str = "";
	if ( $i == "11" ) {
		if ($val == $i ) {
			$str .= '<option selected="selected" value="'.$i.'" style="background-color:#ffaaaa;">即削除</option>';
		} else {
			$str .= '<option value="'.$i.'">即削除</option>';
		}
	} else {
		if ( $val == $i ) {
			$str .= '<option selected="selected" value="'.$i.'">'.number_format($i * 0.1, 1).'</option>';
		} else {
			$str .= '<option value="'.$i.'">'.number_format($i * 0.1, 1).'</option>';
		}
	}
	echo $str;
}

function asm4cmt_mode($array, $var) {
	if ($array["mail"] == 1) {
		$mal[1] = ' selected="selected"';
	} else {
		$mal[0] = ' selected="selected"';
	}
	if ($array["log"] == 1) {
		$log[1] = ' selected="selected"';
	} else {
		$log[0] = ' selected="selected"';
	}
	if ($array["allow"] == 2) {
		$all[2] = ' selected="selected"';
	} elseif ($array["allow"] == 1) {
		$all[1] = ' selected="selected"';
	} else {
		$all[0] = ' selected="selected"';
	}

	$str = '<td><select name="'.$var.'[allow]"><option value="0"'.$all[0].'>許可</option><option value="1"'.$all[1].'>保留</option>';
	if ($var == "spm0" || $var == "spm1") {
		$str .= '<option value="2"'.$all[2].'>削除</option>';
	}
	$str .= '</select></td>
<td><select name="'.$var.'[log]"><option value="0"'.$log[0].'>する</option><option value="1"'.$log[1].'>しない</option></select></td>
<td><select name="'.$var.'[mail]"><option value="0"'.$mal[0].'>通知</option><option value="1"'.$mal[1].'>非通知</option></select></td>';
	return $str;
}

function asm4cmt_reason($str) {
	if ($str) {
		if (strpos($str, "保留")) {
			$str = str_replace("{保留}", "", $str);
		}
		$count = substr_count($str, "[");
		if ($count > 1) {
			$style = ' style="background-color:#ffffaa;display:inline;"';
		} else {
			$style = ' style="display:inline;" disabled="disabled"';
		}
		if ($count) {
			$str = str_replace("[", "<option>", $str);
			$str = str_replace("]", "</option>", $str);
			$str = '<select'.$style.'>'.$str.'</select>';
		}
	}
	return $str;
}

function asm4cmt_format_mes($str) {
	$str = preg_replace("/\[sxcmtpw_[0-9a-zA-Z]+\]/", "", $str);
	$str = preg_replace("/\[sxcicon_[0-9a-zA-Z]+\]/", "[コメントアイコン] ", $str);
	$str = strip_tags($str, "<br>");
	return $str;
}
	
?>
