<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2014/04/14
// Version    : 3.30
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// display.php
//
//--------------------------------------------------------------------

// パスキー生成
$blogn_mod_asm4cmt_keyfile = BLOGN_MODDIR."asm4cmt/key.cgi";
$blogn_mod_asm4cmt_key = file($blogn_mod_asm4cmt_keyfile);
$blogn_mod_asm4cmt_key[0] = rtrim($blogn_mod_asm4cmt_key[0]);
$blogn_mod_asm4cmt_key[1] = rtrim($blogn_mod_asm4cmt_key[1]);
$blogn_mod_asm4cmt_key[2] = rtrim($blogn_mod_asm4cmt_key[2]);
if ((time() - $blogn_mod_asm4cmt_key[2]) > 43200) {
	require BLOGN_MODDIR."asm4cmt/function.php";
	$blogn_mod_asm4cmt_key[1] = $blogn_mod_asm4cmt_key[0];
	$blogn_mod_asm4cmt_key[0] = asm4cmt_create_tsname();
	$blogn_mod_asm4cmt_key[2] = time();
	$fp = fopen($blogn_mod_asm4cmt_keyfile, 'w');
	flock($fp, LOCK_EX); 
	fwrite($fp, "$blogn_mod_asm4cmt_key[0]\r\n$blogn_mod_asm4cmt_key[1]\r\n$blogn_mod_asm4cmt_key[2]\r\n");
	flock($fp, LOCK_UN); 
	fclose($fp);
}

// コメント POST 受け取り
if ($blogn_get_mode == "comment" || $blogn_post_mode == "comment") {
	include(BLOGN_MODDIR."asm4cmt/asm4cmt.php");
	exit;
}

// パスキーをセット
if ($blogn_get_e) {
	$blogn_skin = str_replace("{ASMCN}", $blogn_mod_asm4cmt_key[0], $blogn_skin);
	$blogn_skin = str_replace("{ASMCT}", dechex(time()), $blogn_skin);
	$blogn_skin = str_replace("{TOKEN}", blogn_mod_asm4cmt_make_token($blogn_server_remode_addr), $blogn_skin);
}

// 保留カウンター
if (strpos($blogn_skin, "{ASMCT_COUNT}")) {
	$blogn_mod_asm4cmt_logfile = BLOGN_MODDIR."asm4cmt/rejected.cgi";
	$blogn_mod_asm4cmt_logs = file($blogn_mod_asm4cmt_logfile);
	$blogn_skin = str_replace("{ASMCT_COUNT}", count($blogn_mod_asm4cmt_logs), $blogn_skin);
}

/* ----- トリップ除去（v2.5.x 用） ----- */
function antispam_remove_trip($str) {
	$str = preg_replace("/([\w\W]+?)([◆|■|▲|▼|●|★|◇|□|△|▽|○|☆]+)([\w|\.|\/]{10,})$/", "\\1\\2", $str);
	return $str;
}

function blogn_mod_asm4cmt_make_token($ip) {
	if (BLOGN_MOBILE_KEY) {
		if ($_SERVER['HTTP_X_UP_SUBNO']) {
			$uid = htmlspecialchars(strip_tags($_SERVER['HTTP_X_UP_SUBNO'])); // AU
		} elseif($_SERVER['HTTP_X_JPHONE_UID']) {
			$uid = htmlspecialchars(strip_tags($_SERVER['HTTP_X_JPHONE_UID'])); // Softbank
		} else {
			$uid = htmlspecialchars(strip_tags($_SERVER['HTTP_USER_AGENT']));
		}
		$token = md5($uid);
	} else {
		$token = md5($ip);
		//session_register("asm4cmt_token");
		$_SESSION["asm4cmt_token"] = $token;
	}
	return $token;
}

?>