<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2014/04/14
// Version    : 3.30
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// install.php
//
//--------------------------------------------------------------------

$mod = array(
	"ver"	=>	"3.30",
	"id"	=>	"asm4cmt",
	"name"	=>	"コメントスパム対策モジュール"
);

if (isset($objBlognPlus)) {
	// v2.6.2用
	if (!$objBlognPlus->is_login) {
		header("Content-Type: text/html; charset=UTF-8");
		echo 'セッションエラー。管理画面に入りなおしてください。';
		exit;
	}
} else {
	// v2.6.1以前用
	if (!$_COOKIE["blogn_cookie_pw"]) {
		$blogn_error = blogn_mod_db_user_check($_SESSION["blogn_session_id"], $_SESSION["blogn_session_pw"]);
		if (!$blogn_error[0]) {
			header("Content-Type: text/html; charset=UTF-8");
			echo 'セッションエラー。管理画面に入りなおしてください。';
			exit;
		}
	} else {
		$blogn_error = blogn_mod_db_user_check($_COOKIE["blogn_cookie_id"], $_COOKIE["blogn_cookie_pw"]);
		if (!$blogn_error[0]) {
			header("Content-Type: text/html; charset=UTF-8");
			echo 'セッションエラー。管理画面に入りなおしてください。';
			exit;
		}
	}
}

$information = '
<div style="margin: 0 2em;">
<h2 style="color:#0000ff;font-size:120%;">'.$mod["name"].' ver'.$mod["ver"].'</h2>
<div style="border-left:2px solid #cccccc;margin-left:2em;padding:0 2em;">
<p><span style="color:#008000">■</span> モジュールのインストールが完了しました。</p>';

$information .= file_check("caps", $mod["id"]);
$information .= file_check("config", $mod["id"]);
$information .= file_check("key", $mod["id"]);
$information .= file_check("ngwd", $mod["id"]);
$information .= file_check("rejected", $mod["id"]);

$information .= '
<p><span style="color:#ff0000">■</span> 「PC」用と「携帯」用スキンの投稿フォーム内に独自タグを挿入する必要があります。</p>

<h3>設定</h3>
<ul style="line-height:150%;">
<li><b>優先順位</b>: 一部のモジュールの優先順位と入れ替える必要があります。</li>
<li><b>動作 ON/OFF</b>: 「PC」「携帯」とも 動作 ON/OFF 欄を <img src="'.BLOGN_HOMELINK.'images/on.gif" width="20" height="20" alt="ON" style="vertical-align:middle;" /> にして使ってください。</li>
<li><b>キャッシュ</b>: 非対応</li>
</ul>
</div>
</div>';

function file_check($str, $module) {
	$filename = BLOGN_MODDIR.$module.'/'.$str.'.cgi';
	if (!is_writable($filename)) {
		$info = '<p><span style="color:#ff0000">■</span> /'.$module.'/'.$str.'.cgi のパーミッションに書き込み属性を与えてください（「666」「606」等）。</p>';
	} else {
		$info = '<p><span style="color:#008000">■</span> /'.$module.'/'.$str.'.cgi のパーミッション OK</p>';
	}
	return $info;
}

?>
